%global commit 05db76f3824c52849c27ef87b630b432fba78ca5
%global shortcommit %(c=%{commit}; echo ${c:0:7})

Name:		castxml
Version:	0.1
Release:	%mkrel 0.14.20161006git%{shortcommit}.1
Summary:	C-family abstract syntax tree XML output tool
Group:		Development/C

#		The main program is Apache 2.0
#		src/kwsys/* is BSD
License:	ASL 2.0 and BSD
URL:		https://github.com/CastXML/CastXML
Source0:	https://github.com/CastXML/CastXML/archive/%{commit}/%{name}-%{version}-%{shortcommit}.tar.gz
#		Link against shared llvm library.
#		Currently the libclang.so in Fedora is incomplete, so we
#		can not do the same for the clang library (rhbz 1211943).
Patch0:		%{name}-shared.patch

BuildRequires:	cmake
BuildRequires:	llvm-devel >= 3.9.1
BuildRequires:	llvm >= 3.9.1
BuildRequires:	llvm-static >= 3.9.1
BuildRequires:	clang-devel >= 3.9.1
BuildRequires:	libedit-devel
BuildRequires:	zlib-devel
BuildRequires:	python-sphinx
#		Bundled components of the kitware system library
#		https://fedorahosted.org/fpc/ticket/555
Provides:	bundled(kwsys-encoding)
Provides:	bundled(kwsys-process)
Provides:	bundled(kwsys-system)
Obsoletes:	gccxml < 0.9.0-0.28

%description
Parse C-family source files and optionally write a subset of the
Abstract Syntax Tree (AST) to a representation in XML.

Source files are parsed as complete translation units using the clang
compiler. XML output is enabled by the --castxml-gccxml option and
produces a format close to that of gccxml. Future versions of castxml
may support alternative output formats.

%prep
%setup -q -n CastXML-%{commit}
%patch0 -p1

# LLVM_LIBRARY_DIRS does not work, and can not be overridden with -D flag
sed 's!${LLVM_LIBRARY_DIRS}!${LLVM_LIBRARY_DIR}!' -i CMakeLists.txt

%build
%cmake -DCastXML_INSTALL_DOC_DIR:STRING=share/doc/%{name} \
       -DCastXML_INSTALL_MAN_DIR:STRING=share/man \
       -DLLVM_LIBRARY_DIR=%{_libdir}/llvm \
       -DCLANG_RESOURCE_DIR:PATH=$(clang -print-file-name=include)/.. \
       -DKWSYS_BUILD_SHARED:BOOL=OFF \
       -DBUILD_TESTING:BOOL=ON \
       -DSPHINX_MAN:BOOL=ON
%make

%install
cd build
# (tv) fix install:
sed -i 's!"/../include"!!' cmake_install.cmake
%make_install
rm %{buildroot}%{_defaultdocdir}/%{name}/LICENSE
rm %{buildroot}%{_defaultdocdir}/%{name}/NOTICE

%check
ctest %{?_smp_mflags}

%files
%{_bindir}/castxml
%doc %{_mandir}/man1/castxml.1*
%dir %{_datadir}/%{name}
#{_datadir}/%{name}/clang
%{_datadir}/%{name}/detect_vs.c
%{_datadir}/%{name}/detect_vs.cpp
%{_datadir}/%{name}/empty.c
%{_datadir}/%{name}/empty.cpp
%license LICENSE NOTICE src/kwsys/Copyright.txt


%changelog
* Sat Jan 07 2017 luigiwalser <luigiwalser> 0.1-0.14.20161006git05db76f.1.mga6
+ Revision: 1080519
- update to 20161006 snapshot (from fedora)

  + tmb <tmb>
    - rebuild with new llvm

* Mon Mar 14 2016 tv <tv> 0.1-0.7.20150924git552dd69.1.mga6
+ Revision: 990572
- BR llvm-static
- rebuild for new llvm

* Wed Jan 06 2016 tmb <tmb> 0.1-0.7.20150924git552dd69.mga6
+ Revision: 920079
- rebuild for new llvm

* Thu Oct 29 2015 tv <tv> 0.1-0.6.20150924git552dd69.mga6
+ Revision: 896372
- imported package castxml


* Thu Oct 29 2015 Thierry Vignaud <tv@mageia.org> 0.1-0.6.20150924git552dd69.mga6
- import from FC
